%%%%%%%%%%%%%%%%%%%%%
% Mar 12, 2017
% Turn it into a function
% Add cropping image
%%%%%%%%%%%%%%%%%%%%%
% Mar 10, 2017
% Use my own disparity map disparity_xy
% adjust extracting max to extracting average value
%%%%%%%%%%%%%%%%%%%%%
% Mar 9, 2017
% Add TV Prior
%%%%%%%%%%%%%%%%%%%%%
% Mar 6, 2017
% Disparity Map
%%%%%%%%%%%%%%%%%%%%%

function [result, xmin] = Disparity_f(filename1, filename2)

I1 = im2double(imread(filename1));
I2 = im2double(imread(filename2));

% Setting range for pixel disparity in the y direction
DRangey = [0, 0];
% Setting range for pixel disparity in the x direction
DRange = [10, 186];

% Calculate disparity map for RGB channels, and the gradient in both directions in grey scale image
If1 = disparity_xy( I1(:,:,1), I2(:,:,1), DRangey, 'Method', 'BlockMatching', 'BlockSize', 15,'DisparityRange', DRange, 'UniquenessThreshold', 25 );
If2 = disparity_xy( I1(:,:,2), I2(:,:,2), DRangey, 'Method', 'BlockMatching', 'BlockSize', 15,'DisparityRange', DRange, 'UniquenessThreshold', 25 );
If3 = disparity_xy( I1(:,:,3), I2(:,:,3), DRangey, 'Method', 'BlockMatching', 'BlockSize', 15,'DisparityRange', DRange, 'UniquenessThreshold', 25 );
temp1 = opDx(rgb2gray(I1));
temp2 = opDx(rgb2gray(I2));
If4 = disparity_xy( temp1(:,:,1), temp2(:,:,1), DRangey, 'Method', 'BlockMatching', 'BlockSize', 25,'DisparityRange', DRange, 'UniquenessThreshold', 25 );
If5 = disparity_xy( temp1(:,:,2), temp2(:,:,2), DRangey, 'Method', 'BlockMatching', 'BlockSize', 25,'DisparityRange', DRange, 'UniquenessThreshold', 25 );
% Calculate the final disparity map based on the above results
If = extmean(cat(3, If1, If2, If3, If4, If5), DRange(1));
% To get the border of the depth map, since the two images only overlap part
xmin=1;
while sum(If(:,xmin)>=DRange(1))<100
    xmin=xmin+1;
end

% ADMM + TV prior, getting depth map
Ipf = ProTV(If, 10, .05, DRange, 9, 2);
save('depth_map.mat','If', 'Ipf', 'xmin');

result = Ipf;


% % Showing the results: disparity map and depth map
% figure;
% imshow(If, [DRange(1), max(If(:))]);
% colormap jet
% colorbar
% title('Maximum');
% 
% figure;
% imshow(Ipf, [DRange(1), max(Ipf(:))]);
% colormap jet
% colorbar
% title('ADMM + TV');



end