%%%%%%%%%%%%%%%%%%%%%
% Mar 10, 2017
% Create Weight matrix based on values of pixel and neighbours
%%%%%%%%%%%%%%%%%%%%%

function result = WeightGen(I, DRange, Bsize, sigma);

imageResolution = size(I);
result = zeros(imageResolution);
temp = zeros(4,1);

% Generating weight (credibility) map for each pixel. Generally, if the
% pixel is valid, then it goes to a few neighbor pixels and calculate the
% difference between the value of the pixels. Then it maps the minimum
% difference to a credibility value, which will be used later in ADMM
for i = 1:imageResolution(1)
    for j = 1:imageResolution(2)
        if I(i,j)<DRange(1) 
            result(i,j) = 0;
        else 
            templ = 0;
            if (i-Bsize)>0
                templ = templ+1;
                temp(templ) = abs(I(i-Bsize,j)-I(i,j));
            end
            if (i+Bsize)<=imageResolution(1)
                templ = templ+1;
                temp(templ) = abs(I(i+Bsize,j)-I(i,j));
            end 
            if (j-Bsize)>0
                templ = templ+1;
                temp(templ) = abs(I(i,-Bsize+j)-I(i,j));
            end
            if (j+Bsize)<=imageResolution(2)
                templ = templ+1;
                temp(templ) = abs(I(i,Bsize+j)-I(i,j));
            end 
            result(i,j) = exp(-min(temp(1:templ))^2/sigma);
        end
    end
end

end
